﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using ScheduleCRUDJS.Models;
using System.Collections;
namespace ScheduleCRUDJS.Controllers
{
    public class HomeController : Controller
    {
        ScheduleDataDataContext db = new ScheduleDataDataContext();
       
        public ActionResult Index()
        {
            return View();
        }


        public ActionResult GetData(string CurrentView, DateTime CurrentDate, string CurrentAction)
        {
            var data = AppointmentRepository.FilterAppointment(CurrentDate, CurrentAction, CurrentView);
            BatchDataResult result = new BatchDataResult();
            result.result = data;
          
            result.count = db.Appointments.ToList().Count > 0 ? db.Appointments.ToList().Max(p => p.Id) : 1;
            return Json(result, JsonRequestBehavior.AllowGet);
        }

        public class BatchDataResult
        {
            public IEnumerable result { get; set; }
            public int count { get; set; }
        }

        public JsonResult Batch(EditParams param)
        {
            Appointment result = new Appointment();
            if (param.action == "insert" || (param.action == "batch" && param.added != null))
            {
                var value = param.action == "insert" ? param.value : param.added[0];
                result = AppointmentRepository.Insert(value);
            }
            if ((param.action == "batch" && param.deleted != null) || param.action == "remove")
            {
                if (param.action == "remove")
                    result = AppointmentRepository.Remove(Convert.ToInt32(param.key));
                else
                {
                    foreach (var dele in param.deleted)
                        result = AppointmentRepository.Remove(Convert.ToInt32(dele.Id));
                }
            }
            if ((param.action == "batch" && param.changed != null) || param.action == "update")
            {
                var value = param.action == "update" ? param.value : param.changed[0];
                result = AppointmentRepository.Update(value);
            }
            return Json(result, JsonRequestBehavior.AllowGet);
        }       
    }
    
}